# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetCloudProjectRancherCapabilitiesVersionResult',
    'AwaitableGetCloudProjectRancherCapabilitiesVersionResult',
    'get_cloud_project_rancher_capabilities_version',
    'get_cloud_project_rancher_capabilities_version_output',
]

@pulumi.output_type
class GetCloudProjectRancherCapabilitiesVersionResult:
    """
    A collection of values returned by getCloudProjectRancherCapabilitiesVersion.
    """
    def __init__(__self__, id=None, project_id=None, rancher_id=None, versions=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if project_id and not isinstance(project_id, str):
            raise TypeError("Expected argument 'project_id' to be a str")
        pulumi.set(__self__, "project_id", project_id)
        if rancher_id and not isinstance(rancher_id, str):
            raise TypeError("Expected argument 'rancher_id' to be a str")
        pulumi.set(__self__, "rancher_id", rancher_id)
        if versions and not isinstance(versions, list):
            raise TypeError("Expected argument 'versions' to be a list")
        pulumi.set(__self__, "versions", versions)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="projectId")
    def project_id(self) -> builtins.str:
        """
        Project ID
        """
        return pulumi.get(self, "project_id")

    @property
    @pulumi.getter(name="rancherId")
    def rancher_id(self) -> builtins.str:
        """
        Rancher ID
        """
        return pulumi.get(self, "rancher_id")

    @property
    @pulumi.getter
    def versions(self) -> Sequence['outputs.GetCloudProjectRancherCapabilitiesVersionVersionResult']:
        return pulumi.get(self, "versions")


class AwaitableGetCloudProjectRancherCapabilitiesVersionResult(GetCloudProjectRancherCapabilitiesVersionResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetCloudProjectRancherCapabilitiesVersionResult(
            id=self.id,
            project_id=self.project_id,
            rancher_id=self.rancher_id,
            versions=self.versions)


def get_cloud_project_rancher_capabilities_version(project_id: Optional[builtins.str] = None,
                                                   rancher_id: Optional[builtins.str] = None,
                                                   opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetCloudProjectRancherCapabilitiesVersionResult:
    """
    List available and current versions for the given managed Rancher service

    ## Example Usage

    ```python
    import pulumi
    import pulumi_ovh as ovh

    versions = ovh.get_cloud_project_rancher_capabilities_version(project_id="XXX",
        rancher_id="YYY")
    ```


    :param builtins.str project_id: Project ID
    :param builtins.str rancher_id: Rancher ID
    """
    __args__ = dict()
    __args__['projectId'] = project_id
    __args__['rancherId'] = rancher_id
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('ovh:index/getCloudProjectRancherCapabilitiesVersion:getCloudProjectRancherCapabilitiesVersion', __args__, opts=opts, typ=GetCloudProjectRancherCapabilitiesVersionResult).value

    return AwaitableGetCloudProjectRancherCapabilitiesVersionResult(
        id=pulumi.get(__ret__, 'id'),
        project_id=pulumi.get(__ret__, 'project_id'),
        rancher_id=pulumi.get(__ret__, 'rancher_id'),
        versions=pulumi.get(__ret__, 'versions'))
def get_cloud_project_rancher_capabilities_version_output(project_id: Optional[pulumi.Input[builtins.str]] = None,
                                                          rancher_id: Optional[pulumi.Input[builtins.str]] = None,
                                                          opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetCloudProjectRancherCapabilitiesVersionResult]:
    """
    List available and current versions for the given managed Rancher service

    ## Example Usage

    ```python
    import pulumi
    import pulumi_ovh as ovh

    versions = ovh.get_cloud_project_rancher_capabilities_version(project_id="XXX",
        rancher_id="YYY")
    ```


    :param builtins.str project_id: Project ID
    :param builtins.str rancher_id: Rancher ID
    """
    __args__ = dict()
    __args__['projectId'] = project_id
    __args__['rancherId'] = rancher_id
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('ovh:index/getCloudProjectRancherCapabilitiesVersion:getCloudProjectRancherCapabilitiesVersion', __args__, opts=opts, typ=GetCloudProjectRancherCapabilitiesVersionResult)
    return __ret__.apply(lambda __response__: GetCloudProjectRancherCapabilitiesVersionResult(
        id=pulumi.get(__response__, 'id'),
        project_id=pulumi.get(__response__, 'project_id'),
        rancher_id=pulumi.get(__response__, 'rancher_id'),
        versions=pulumi.get(__response__, 'versions')))
