# coding=utf-8
# *** WARNING: this file was generated by pulumi-language-python. ***
# *** Do not edit by hand unless you're certain you know what you are doing! ***

import builtins
import copy
import warnings
import sys
import pulumi
import pulumi.runtime
from typing import Any, Mapping, Optional, Sequence, Union, overload
if sys.version_info >= (3, 11):
    from typing import NotRequired, TypedDict, TypeAlias
else:
    from typing_extensions import NotRequired, TypedDict, TypeAlias
from . import _utilities
from . import outputs

__all__ = [
    'GetOvhcloudConnectConfigPopsResult',
    'AwaitableGetOvhcloudConnectConfigPopsResult',
    'get_ovhcloud_connect_config_pops',
    'get_ovhcloud_connect_config_pops_output',
]

@pulumi.output_type
class GetOvhcloudConnectConfigPopsResult:
    """
    A collection of values returned by getOvhcloudConnectConfigPops.
    """
    def __init__(__self__, id=None, pop_configs=None, service_name=None):
        if id and not isinstance(id, str):
            raise TypeError("Expected argument 'id' to be a str")
        pulumi.set(__self__, "id", id)
        if pop_configs and not isinstance(pop_configs, list):
            raise TypeError("Expected argument 'pop_configs' to be a list")
        pulumi.set(__self__, "pop_configs", pop_configs)
        if service_name and not isinstance(service_name, str):
            raise TypeError("Expected argument 'service_name' to be a str")
        pulumi.set(__self__, "service_name", service_name)

    @property
    @pulumi.getter
    def id(self) -> builtins.str:
        """
        The provider-assigned unique ID for this managed resource.
        """
        return pulumi.get(self, "id")

    @property
    @pulumi.getter(name="popConfigs")
    def pop_configs(self) -> Sequence['outputs.GetOvhcloudConnectConfigPopsPopConfigResult']:
        return pulumi.get(self, "pop_configs")

    @property
    @pulumi.getter(name="serviceName")
    def service_name(self) -> builtins.str:
        """
        Service name
        """
        return pulumi.get(self, "service_name")


class AwaitableGetOvhcloudConnectConfigPopsResult(GetOvhcloudConnectConfigPopsResult):
    # pylint: disable=using-constant-test
    def __await__(self):
        if False:
            yield self
        return GetOvhcloudConnectConfigPopsResult(
            id=self.id,
            pop_configs=self.pop_configs,
            service_name=self.service_name)


def get_ovhcloud_connect_config_pops(service_name: Optional[builtins.str] = None,
                                     opts: Optional[pulumi.InvokeOptions] = None) -> AwaitableGetOvhcloudConnectConfigPopsResult:
    """
    Use this data source to retrieve information about an Ovhcloud Connect Pop configuration

    ## Example Usage

    ```python
    import pulumi
    import pulumi_ovh as ovh

    pop_cfgs = ovh.get_ovhcloud_connect_config_pops(service_name="XXX")
    ```


    :param builtins.str service_name: Service name
    """
    __args__ = dict()
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke('ovh:index/getOvhcloudConnectConfigPops:getOvhcloudConnectConfigPops', __args__, opts=opts, typ=GetOvhcloudConnectConfigPopsResult).value

    return AwaitableGetOvhcloudConnectConfigPopsResult(
        id=pulumi.get(__ret__, 'id'),
        pop_configs=pulumi.get(__ret__, 'pop_configs'),
        service_name=pulumi.get(__ret__, 'service_name'))
def get_ovhcloud_connect_config_pops_output(service_name: Optional[pulumi.Input[builtins.str]] = None,
                                            opts: Optional[Union[pulumi.InvokeOptions, pulumi.InvokeOutputOptions]] = None) -> pulumi.Output[GetOvhcloudConnectConfigPopsResult]:
    """
    Use this data source to retrieve information about an Ovhcloud Connect Pop configuration

    ## Example Usage

    ```python
    import pulumi
    import pulumi_ovh as ovh

    pop_cfgs = ovh.get_ovhcloud_connect_config_pops(service_name="XXX")
    ```


    :param builtins.str service_name: Service name
    """
    __args__ = dict()
    __args__['serviceName'] = service_name
    opts = pulumi.InvokeOutputOptions.merge(_utilities.get_invoke_opts_defaults(), opts)
    __ret__ = pulumi.runtime.invoke_output('ovh:index/getOvhcloudConnectConfigPops:getOvhcloudConnectConfigPops', __args__, opts=opts, typ=GetOvhcloudConnectConfigPopsResult)
    return __ret__.apply(lambda __response__: GetOvhcloudConnectConfigPopsResult(
        id=pulumi.get(__response__, 'id'),
        pop_configs=pulumi.get(__response__, 'pop_configs'),
        service_name=pulumi.get(__response__, 'service_name')))
